Codeforces Round #369 (Div. 2) C. Coloring Trees 动态规划

时间:2023-03-09 18:24:14
Codeforces Round #369 (Div. 2) C. Coloring Trees 动态规划

C. Coloring Trees

题目连接:

http://www.codeforces.com/contest/711/problem/C

Description

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, n, m and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color j. pi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Sample Input

3 2 2

0 0 0

1 2

3 4

5 6

Sample Output

10

Hint

题意

给你\(n\)棵树,如果\(c_i\)为0的话,那么这棵树就没有上色,否则这棵树就是\(c_i\)颜色的。

相同颜色的树会被当成一段,现在你要恰好刷漆刷成k段,问你最小花费是多少。

把第i棵树刷漆刷成j颜色的花费为\(p[i][j]\)

题解:

dp[i][j][k]表示第i棵树,刷成了j颜色,当前有k段的最小花费是多少。

然后好礼n4转移就好了,很容易就能够优化成空间n2,时间n^3的。

不优化也能过。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 105;
const long long inf = 1000000000000000LL;
long long dp[2][maxn][maxn];
int n,m,K;
int c[maxn],p[maxn];
int now,pre=1;
int main()
{
scanf("%d%d%d",&n,&m,&K);
for(int i=1;i<=n;i++)
scanf("%d",&c[i]);
for(int j=0;j<=m;j++)
for(int k=0;k<=n;k++)
dp[now][j][k]=inf;
for(int j=1;j<=m;j++)
scanf("%d",&p[j]);
if(c[1]==0)
{
for(int j=1;j<=m;j++)
dp[now][j][1]=p[j];
}
else
dp[now][c[1]][1]=0;
for(int i=2;i<=n;i++)
{
swap(pre,now);
for(int j=0;j<=m;j++)
for(int k=0;k<=n;k++)
dp[now][j][k]=inf;
for(int j=1;j<=m;j++)
scanf("%d",&p[j]);
if(c[i]==0)
{
for(int j=1;j<=m;j++)
for(int k=1;k<=n;k++)
{
dp[now][j][k]=min(dp[now][j][k],dp[pre][j][k]+p[j]);
for(int t=1;t<=m;t++)
{
if(t==j)continue;
dp[now][j][k]=min(dp[now][j][k],dp[pre][t][k-1]+p[j]);
}
}
}
else
{
for(int k=1;k<=n;k++)
{
dp[now][c[i]][k]=min(dp[now][c[i]][k],dp[pre][c[i]][k]);
for(int t=1;t<=m;t++)
{
if(t==c[i])continue;
dp[now][c[i]][k]=min(dp[now][c[i]][k],dp[pre][t][k-1]);
}
}
}
}
long long ans = inf;
for(int i=1;i<=m;i++)
ans=min(ans,dp[now][i][K]);
if(ans>=inf)printf("-1\n");
else printf("%lld\n",ans);
}